package com.izouma.nineth.web;
import com.izouma.nineth.domain.Like;
import com.izouma.nineth.service.LikeService;
import com.izouma.nineth.dto.PageQuery;
import com.izouma.nineth.exception.BusinessException;
import com.izouma.nineth.repo.LikeRepo;
import com.izouma.nineth.utils.ObjUtils;
import com.izouma.nineth.utils.excel.ExcelUtils;
import lombok.AllArgsConstructor;
import org.springframework.data.domain.Page;
import org.springframework.security.access.prepost.PreAuthorize;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletResponse;
import java.io.IOException;
import java.util.List;

@RestController
@RequestMapping("/like")
@AllArgsConstructor
public class LikeController extends BaseController {
    private LikeService likeService;
    private LikeRepo likeRepo;

    //@PreAuthorize("hasRole('ADMIN')")
    @PostMapping("/save")
    public Like save(@RequestBody Like record) {
        if (record.getId() != null) {
            Like orig = likeRepo.findById(record.getId()).orElseThrow(new BusinessException("无记录"));
            ObjUtils.merge(orig, record);
            return likeRepo.save(orig);
        }
        return likeRepo.save(record);
    }

    //@PreAuthorize("hasRole('ADMIN')")
    @PostMapping("/all")
    public Page<Like> all(@RequestBody PageQuery pageQuery) {
        return likeService.all(pageQuery);
    }

    @GetMapping("/get/{id}")
    public Like get(@PathVariable Long id) {
        return likeRepo.findById(id).orElseThrow(new BusinessException("无记录"));
    }

    @PostMapping("/del/{id}")
    public void del(@PathVariable Long id) {
        likeRepo.softDelete(id);
    }

    @GetMapping("/excel")
    @ResponseBody
    public void excel(HttpServletResponse response, PageQuery pageQuery) throws IOException {
        List<Like> data = all(pageQuery).getContent();
        ExcelUtils.export(response, data);
    }
}

